using System;
using System.Drawing;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using System.Xml;

namespace Glow
{
	public class RainmakerForm : System.Windows.Forms.Form
	{
		private Image[] images;
		private Graphics[] graphics;
		int frames = 15;
		int frame  = 0;
		// Kulturunabhngiges (invariantes) Zahlenformat zum Speichern verwenden.
		private System.Globalization.NumberFormatInfo format =
			System.Globalization.CultureInfo.InvariantCulture.NumberFormat;

		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.Timer timerPaint;
		private System.Windows.Forms.Panel panelSettings;
		private System.Windows.Forms.NumericUpDown numericUpDownMin;
		private System.Windows.Forms.NumericUpDown numericUpDownOut;
		private System.Windows.Forms.NumericUpDown numericUpDownGravity;
		private System.Windows.Forms.Label labelTrail;
		private System.Windows.Forms.Label labelSize;
		private System.Windows.Forms.NumericUpDown numericUpDownTrail;
		private System.Windows.Forms.NumericUpDown numericUpDownSize;
		private System.Windows.Forms.NumericUpDown numericUpDownCount;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.NumericUpDown numericUpDownIn;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.NumericUpDown numericUpDownAlpha;
		private System.Windows.Forms.StatusBar statusBar;
		private System.Windows.Forms.Label labelFrames;
		private System.Windows.Forms.NumericUpDown numericUpDownFrames;
		private System.Windows.Forms.Label labelHeight;
		private System.Windows.Forms.NumericUpDown numericUpDownHeight;
		private System.Windows.Forms.Label labelWidth;
		private System.Windows.Forms.NumericUpDown numericUpDownWidth;
		private System.Windows.Forms.Label labelMin;
		private System.Windows.Forms.Label labelGravity;
		private System.Windows.Forms.NumericUpDown numericUpDownSlope;
		private System.Windows.Forms.Label labelSlope;
		private System.Windows.Forms.Button buttonSave;
		private System.Windows.Forms.SaveFileDialog saveFileDialog;
		private System.Windows.Forms.OpenFileDialog openFileDialog;
		private System.Windows.Forms.Button buttonLoad;

		public RainmakerForm()
		{
			InitializeComponent();

			// Double-Buffering verzgert das Zeichnen ein wenig, dafr flackert es nicht.
			SetStyle(ControlStyles.AllPaintingInWmPaint, true);
			SetStyle(ControlStyles.DoubleBuffer,         true);
			SetStyle(ControlStyles.UserPaint,            true);

			// Nicht sehr elegant, aber diese Variante ist kompatibel zum Compact Framework.
			openFileDialog.InitialDirectory = System.IO.Path.GetDirectoryName(
				System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase).
				Replace(@"file:\", "");
			saveFileDialog.InitialDirectory = openFileDialog.InitialDirectory;
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.timerPaint = new System.Windows.Forms.Timer(this.components);
			this.panelSettings = new System.Windows.Forms.Panel();
			this.buttonLoad = new System.Windows.Forms.Button();
			this.buttonSave = new System.Windows.Forms.Button();
			this.numericUpDownSlope = new System.Windows.Forms.NumericUpDown();
			this.labelSlope = new System.Windows.Forms.Label();
			this.numericUpDownHeight = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownWidth = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownFrames = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownAlpha = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownIn = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownCount = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownTrail = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownSize = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownOut = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownGravity = new System.Windows.Forms.NumericUpDown();
			this.numericUpDownMin = new System.Windows.Forms.NumericUpDown();
			this.labelGravity = new System.Windows.Forms.Label();
			this.labelMin = new System.Windows.Forms.Label();
			this.labelHeight = new System.Windows.Forms.Label();
			this.labelWidth = new System.Windows.Forms.Label();
			this.labelFrames = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.labelTrail = new System.Windows.Forms.Label();
			this.labelSize = new System.Windows.Forms.Label();
			this.statusBar = new System.Windows.Forms.StatusBar();
			this.saveFileDialog = new System.Windows.Forms.SaveFileDialog();
			this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
			this.panelSettings.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownSlope)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownHeight)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownWidth)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownFrames)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownAlpha)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownIn)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownCount)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownTrail)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownSize)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownOut)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownGravity)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownMin)).BeginInit();
			this.SuspendLayout();
			// 
			// timerPaint
			// 
			this.timerPaint.Enabled = true;
			this.timerPaint.Interval = 33;
			this.timerPaint.Tick += new System.EventHandler(this.timerPaint_Tick);
			// 
			// panelSettings
			// 
			this.panelSettings.Controls.Add(this.buttonLoad);
			this.panelSettings.Controls.Add(this.buttonSave);
			this.panelSettings.Controls.Add(this.numericUpDownSlope);
			this.panelSettings.Controls.Add(this.labelSlope);
			this.panelSettings.Controls.Add(this.numericUpDownHeight);
			this.panelSettings.Controls.Add(this.numericUpDownWidth);
			this.panelSettings.Controls.Add(this.numericUpDownFrames);
			this.panelSettings.Controls.Add(this.numericUpDownAlpha);
			this.panelSettings.Controls.Add(this.numericUpDownIn);
			this.panelSettings.Controls.Add(this.numericUpDownCount);
			this.panelSettings.Controls.Add(this.numericUpDownTrail);
			this.panelSettings.Controls.Add(this.numericUpDownSize);
			this.panelSettings.Controls.Add(this.numericUpDownOut);
			this.panelSettings.Controls.Add(this.numericUpDownGravity);
			this.panelSettings.Controls.Add(this.numericUpDownMin);
			this.panelSettings.Controls.Add(this.labelGravity);
			this.panelSettings.Controls.Add(this.labelMin);
			this.panelSettings.Controls.Add(this.labelHeight);
			this.panelSettings.Controls.Add(this.labelWidth);
			this.panelSettings.Controls.Add(this.labelFrames);
			this.panelSettings.Controls.Add(this.label4);
			this.panelSettings.Controls.Add(this.label3);
			this.panelSettings.Controls.Add(this.label2);
			this.panelSettings.Controls.Add(this.label1);
			this.panelSettings.Controls.Add(this.labelTrail);
			this.panelSettings.Controls.Add(this.labelSize);
			this.panelSettings.Dock = System.Windows.Forms.DockStyle.Right;
			this.panelSettings.Location = new System.Drawing.Point(387, 0);
			this.panelSettings.Name = "panelSettings";
			this.panelSettings.Size = new System.Drawing.Size(205, 544);
			this.panelSettings.TabIndex = 0;
			// 
			// buttonLoad
			// 
			this.buttonLoad.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.buttonLoad.Location = new System.Drawing.Point(12, 363);
			this.buttonLoad.Name = "buttonLoad";
			this.buttonLoad.Size = new System.Drawing.Size(181, 23);
			this.buttonLoad.TabIndex = 25;
			this.buttonLoad.Text = "Load... (F3)";
			this.buttonLoad.Click += new System.EventHandler(this.buttonLoad_Click);
			// 
			// buttonSave
			// 
			this.buttonSave.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.buttonSave.Location = new System.Drawing.Point(12, 392);
			this.buttonSave.Name = "buttonSave";
			this.buttonSave.Size = new System.Drawing.Size(181, 23);
			this.buttonSave.TabIndex = 24;
			this.buttonSave.Text = "Save as... (F2)";
			this.buttonSave.Click += new System.EventHandler(this.buttonSave_Click);
			// 
			// numericUpDownSlope
			// 
			this.numericUpDownSlope.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.numericUpDownSlope.DecimalPlaces = 2;
			this.numericUpDownSlope.Increment = new System.Decimal(new int[] {
																				 1,
																				 0,
																				 0,
																				 131072});
			this.numericUpDownSlope.Location = new System.Drawing.Point(133, 129);
			this.numericUpDownSlope.Maximum = new System.Decimal(new int[] {
																			   1000,
																			   0,
																			   0,
																			   0});
			this.numericUpDownSlope.Name = "numericUpDownSlope";
			this.numericUpDownSlope.Size = new System.Drawing.Size(60, 20);
			this.numericUpDownSlope.TabIndex = 22;
			this.numericUpDownSlope.Value = new System.Decimal(new int[] {
																			 2,
																			 0,
																			 0,
																			 65536});
			this.numericUpDownSlope.ValueChanged += new System.EventHandler(this.numericUpDown_ValueChanged);
			// 
			// labelSlope
			// 
			this.labelSlope.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.labelSlope.Location = new System.Drawing.Point(3, 131);
			this.labelSlope.Name = "labelSlope";
			this.labelSlope.Size = new System.Drawing.Size(124, 18);
			this.labelSlope.TabIndex = 23;
			this.labelSlope.Text = "Slope:";
			this.labelSlope.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// numericUpDownHeight
			// 
			this.numericUpDownHeight.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.numericUpDownHeight.Increment = new System.Decimal(new int[] {
																				  32,
																				  0,
																				  0,
																				  0});
			this.numericUpDownHeight.Location = new System.Drawing.Point(133, 38);
			this.numericUpDownHeight.Maximum = new System.Decimal(new int[] {
																				1024,
																				0,
																				0,
																				0});
			this.numericUpDownHeight.Minimum = new System.Decimal(new int[] {
																				32,
																				0,
																				0,
																				0});
			this.numericUpDownHeight.Name = "numericUpDownHeight";
			this.numericUpDownHeight.Size = new System.Drawing.Size(60, 20);
			this.numericUpDownHeight.TabIndex = 18;
			this.numericUpDownHeight.Value = new System.Decimal(new int[] {
																			  128,
																			  0,
																			  0,
																			  0});
			this.numericUpDownHeight.ValueChanged += new System.EventHandler(this.numericUpDown_ValueChanged);
			// 
			// numericUpDownWidth
			// 
			this.numericUpDownWidth.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.numericUpDownWidth.Increment = new System.Decimal(new int[] {
																				 32,
																				 0,
																				 0,
																				 0});
			this.numericUpDownWidth.Location = new System.Drawing.Point(133, 12);
			this.numericUpDownWidth.Maximum = new System.Decimal(new int[] {
																			   1024,
																			   0,
																			   0,
																			   0});
			this.numericUpDownWidth.Minimum = new System.Decimal(new int[] {
																			   32,
																			   0,
																			   0,
																			   0});
			this.numericUpDownWidth.Name = "numericUpDownWidth";
			this.numericUpDownWidth.Size = new System.Drawing.Size(60, 20);
			this.numericUpDownWidth.TabIndex = 16;
			this.numericUpDownWidth.Value = new System.Decimal(new int[] {
																			 128,
																			 0,
																			 0,
																			 0});
			this.numericUpDownWidth.ValueChanged += new System.EventHandler(this.numericUpDown_ValueChanged);
			// 
			// numericUpDownFrames
			// 
			this.numericUpDownFrames.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.numericUpDownFrames.Location = new System.Drawing.Point(133, 64);
			this.numericUpDownFrames.Minimum = new System.Decimal(new int[] {
																				1,
																				0,
																				0,
																				0});
			this.numericUpDownFrames.Name = "numericUpDownFrames";
			this.numericUpDownFrames.Size = new System.Drawing.Size(60, 20);
			this.numericUpDownFrames.TabIndex = 14;
			this.numericUpDownFrames.Value = new System.Decimal(new int[] {
																			  15,
																			  0,
																			  0,
																			  0});
			this.numericUpDownFrames.ValueChanged += new System.EventHandler(this.numericUpDown_ValueChanged);
			// 
			// numericUpDownAlpha
			// 
			this.numericUpDownAlpha.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.numericUpDownAlpha.Increment = new System.Decimal(new int[] {
																				 64,
																				 0,
																				 0,
																				 0});
			this.numericUpDownAlpha.Location = new System.Drawing.Point(133, 311);
			this.numericUpDownAlpha.Maximum = new System.Decimal(new int[] {
																			   10000,
																			   0,
																			   0,
																			   0});
			this.numericUpDownAlpha.Name = "numericUpDownAlpha";
			this.numericUpDownAlpha.Size = new System.Drawing.Size(60, 20);
			this.numericUpDownAlpha.TabIndex = 12;
			this.numericUpDownAlpha.Value = new System.Decimal(new int[] {
																			 512,
																			 0,
																			 0,
																			 0});
			this.numericUpDownAlpha.ValueChanged += new System.EventHandler(this.numericUpDown_ValueChanged);
			// 
			// numericUpDownIn
			// 
			this.numericUpDownIn.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.numericUpDownIn.DecimalPlaces = 1;
			this.numericUpDownIn.Increment = new System.Decimal(new int[] {
																			  1,
																			  0,
																			  0,
																			  65536});
			this.numericUpDownIn.Location = new System.Drawing.Point(133, 285);
			this.numericUpDownIn.Name = "numericUpDownIn";
			this.numericUpDownIn.Size = new System.Drawing.Size(60, 20);
			this.numericUpDownIn.TabIndex = 10;
			this.numericUpDownIn.Value = new System.Decimal(new int[] {
																		  5,
																		  0,
																		  0,
																		  65536});
			this.numericUpDownIn.ValueChanged += new System.EventHandler(this.numericUpDown_ValueChanged);
			// 
			// numericUpDownCount
			// 
			this.numericUpDownCount.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.numericUpDownCount.Increment = new System.Decimal(new int[] {
																				 10,
																				 0,
																				 0,
																				 0});
			this.numericUpDownCount.Location = new System.Drawing.Point(133, 103);
			this.numericUpDownCount.Maximum = new System.Decimal(new int[] {
																			   10000,
																			   0,
																			   0,
																			   0});
			this.numericUpDownCount.Minimum = new System.Decimal(new int[] {
																			   1,
																			   0,
																			   0,
																			   0});
			this.numericUpDownCount.Name = "numericUpDownCount";
			this.numericUpDownCount.Size = new System.Drawing.Size(60, 20);
			this.numericUpDownCount.TabIndex = 7;
			this.numericUpDownCount.Value = new System.Decimal(new int[] {
																			 10,
																			 0,
																			 0,
																			 0});
			this.numericUpDownCount.ValueChanged += new System.EventHandler(this.numericUpDown_ValueChanged);
			// 
			// numericUpDownTrail
			// 
			this.numericUpDownTrail.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.numericUpDownTrail.DecimalPlaces = 1;
			this.numericUpDownTrail.Increment = new System.Decimal(new int[] {
																				 1,
																				 0,
																				 0,
																				 65536});
			this.numericUpDownTrail.Location = new System.Drawing.Point(133, 181);
			this.numericUpDownTrail.Name = "numericUpDownTrail";
			this.numericUpDownTrail.Size = new System.Drawing.Size(60, 20);
			this.numericUpDownTrail.TabIndex = 4;
			this.numericUpDownTrail.Value = new System.Decimal(new int[] {
																			 4,
																			 0,
																			 0,
																			 0});
			this.numericUpDownTrail.ValueChanged += new System.EventHandler(this.numericUpDown_ValueChanged);
			// 
			// numericUpDownSize
			// 
			this.numericUpDownSize.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.numericUpDownSize.DecimalPlaces = 1;
			this.numericUpDownSize.Increment = new System.Decimal(new int[] {
																				1,
																				0,
																				0,
																				65536});
			this.numericUpDownSize.Location = new System.Drawing.Point(133, 155);
			this.numericUpDownSize.Name = "numericUpDownSize";
			this.numericUpDownSize.Size = new System.Drawing.Size(60, 20);
			this.numericUpDownSize.TabIndex = 3;
			this.numericUpDownSize.Value = new System.Decimal(new int[] {
																			2,
																			0,
																			0,
																			0});
			this.numericUpDownSize.ValueChanged += new System.EventHandler(this.numericUpDown_ValueChanged);
			// 
			// numericUpDownOut
			// 
			this.numericUpDownOut.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.numericUpDownOut.Location = new System.Drawing.Point(133, 337);
			this.numericUpDownOut.Maximum = new System.Decimal(new int[] {
																			 1000,
																			 0,
																			 0,
																			 0});
			this.numericUpDownOut.Minimum = new System.Decimal(new int[] {
																			 1,
																			 0,
																			 0,
																			 0});
			this.numericUpDownOut.Name = "numericUpDownOut";
			this.numericUpDownOut.Size = new System.Drawing.Size(60, 20);
			this.numericUpDownOut.TabIndex = 2;
			this.numericUpDownOut.Value = new System.Decimal(new int[] {
																		   8,
																		   0,
																		   0,
																		   0});
			this.numericUpDownOut.ValueChanged += new System.EventHandler(this.numericUpDown_ValueChanged);
			// 
			// numericUpDownGravity
			// 
			this.numericUpDownGravity.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.numericUpDownGravity.DecimalPlaces = 3;
			this.numericUpDownGravity.Increment = new System.Decimal(new int[] {
																				   1,
																				   0,
																				   0,
																				   131072});
			this.numericUpDownGravity.Location = new System.Drawing.Point(133, 246);
			this.numericUpDownGravity.Minimum = new System.Decimal(new int[] {
																				 100,
																				 0,
																				 0,
																				 -2147483648});
			this.numericUpDownGravity.Name = "numericUpDownGravity";
			this.numericUpDownGravity.Size = new System.Drawing.Size(60, 20);
			this.numericUpDownGravity.TabIndex = 1;
			this.numericUpDownGravity.Value = new System.Decimal(new int[] {
																			   2,
																			   0,
																			   0,
																			   65536});
			this.numericUpDownGravity.ValueChanged += new System.EventHandler(this.numericUpDown_ValueChanged);
			// 
			// numericUpDownMin
			// 
			this.numericUpDownMin.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.numericUpDownMin.DecimalPlaces = 1;
			this.numericUpDownMin.Increment = new System.Decimal(new int[] {
																			   1,
																			   0,
																			   0,
																			   65536});
			this.numericUpDownMin.Location = new System.Drawing.Point(133, 220);
			this.numericUpDownMin.Minimum = new System.Decimal(new int[] {
																			 100,
																			 0,
																			 0,
																			 -2147483648});
			this.numericUpDownMin.Name = "numericUpDownMin";
			this.numericUpDownMin.Size = new System.Drawing.Size(60, 20);
			this.numericUpDownMin.TabIndex = 0;
			this.numericUpDownMin.Value = new System.Decimal(new int[] {
																		   2,
																		   0,
																		   0,
																		   65536});
			this.numericUpDownMin.ValueChanged += new System.EventHandler(this.numericUpDown_ValueChanged);
			// 
			// labelGravity
			// 
			this.labelGravity.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.labelGravity.Location = new System.Drawing.Point(3, 248);
			this.labelGravity.Name = "labelGravity";
			this.labelGravity.Size = new System.Drawing.Size(124, 18);
			this.labelGravity.TabIndex = 21;
			this.labelGravity.Text = "Gravity:";
			this.labelGravity.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// labelMin
			// 
			this.labelMin.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.labelMin.Location = new System.Drawing.Point(3, 222);
			this.labelMin.Name = "labelMin";
			this.labelMin.Size = new System.Drawing.Size(124, 18);
			this.labelMin.TabIndex = 20;
			this.labelMin.Text = "Start speed:";
			this.labelMin.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// labelHeight
			// 
			this.labelHeight.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.labelHeight.Location = new System.Drawing.Point(3, 40);
			this.labelHeight.Name = "labelHeight";
			this.labelHeight.Size = new System.Drawing.Size(124, 18);
			this.labelHeight.TabIndex = 19;
			this.labelHeight.Text = "Bitmap height:";
			this.labelHeight.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// labelWidth
			// 
			this.labelWidth.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.labelWidth.Location = new System.Drawing.Point(3, 14);
			this.labelWidth.Name = "labelWidth";
			this.labelWidth.Size = new System.Drawing.Size(124, 18);
			this.labelWidth.TabIndex = 17;
			this.labelWidth.Text = "Bitmap width:";
			this.labelWidth.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// labelFrames
			// 
			this.labelFrames.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.labelFrames.Location = new System.Drawing.Point(3, 66);
			this.labelFrames.Name = "labelFrames";
			this.labelFrames.Size = new System.Drawing.Size(124, 18);
			this.labelFrames.TabIndex = 15;
			this.labelFrames.Text = "Total number of frames:";
			this.labelFrames.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label4
			// 
			this.label4.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.label4.Location = new System.Drawing.Point(3, 313);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(124, 18);
			this.label4.TabIndex = 13;
			this.label4.Text = "Alpha start:";
			this.label4.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label3
			// 
			this.label3.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.label3.Location = new System.Drawing.Point(3, 287);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(124, 18);
			this.label3.TabIndex = 11;
			this.label3.Text = "Fade in:";
			this.label3.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label2
			// 
			this.label2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.label2.Location = new System.Drawing.Point(3, 339);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(124, 18);
			this.label2.TabIndex = 9;
			this.label2.Text = "Alpha fade out:";
			this.label2.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.label1.Location = new System.Drawing.Point(3, 105);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(124, 18);
			this.label1.TabIndex = 8;
			this.label1.Text = "Particle count:";
			this.label1.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// labelTrail
			// 
			this.labelTrail.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.labelTrail.Location = new System.Drawing.Point(3, 183);
			this.labelTrail.Name = "labelTrail";
			this.labelTrail.Size = new System.Drawing.Size(124, 18);
			this.labelTrail.TabIndex = 6;
			this.labelTrail.Text = "Particle trail:";
			this.labelTrail.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// labelSize
			// 
			this.labelSize.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.labelSize.Location = new System.Drawing.Point(3, 157);
			this.labelSize.Name = "labelSize";
			this.labelSize.Size = new System.Drawing.Size(124, 18);
			this.labelSize.TabIndex = 5;
			this.labelSize.Text = "Particle size:";
			this.labelSize.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// statusBar
			// 
			this.statusBar.Location = new System.Drawing.Point(0, 544);
			this.statusBar.Name = "statusBar";
			this.statusBar.Size = new System.Drawing.Size(592, 22);
			this.statusBar.TabIndex = 1;
			this.statusBar.Text = "Ready";
			// 
			// saveFileDialog
			// 
			this.saveFileDialog.Filter = "Cascademaker settings (*.xml)|*.xml|PNG image sequence (*.png)|*.png";
			this.saveFileDialog.Title = "Save as...";
			// 
			// openFileDialog
			// 
			this.openFileDialog.Filter = "Cascademaker settings (*.xml)|*.xml";
			this.openFileDialog.Title = "Load...";
			// 
			// RainmakerForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(592, 566);
			this.Controls.Add(this.panelSettings);
			this.Controls.Add(this.statusBar);
			this.KeyPreview = true;
			this.Name = "RainmakerForm";
			this.Text = "Glow Rainmaker 0.1 alpha";
			this.KeyDown += new System.Windows.Forms.KeyEventHandler(this.RainmakerForm_KeyDown);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.FormCascademaker_Paint);
			this.panelSettings.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownSlope)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownHeight)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownWidth)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownFrames)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownAlpha)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownIn)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownCount)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownTrail)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownSize)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownOut)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownGravity)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownMin)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main()
		{
			Application.EnableVisualStyles();
			Application.Run(new RainmakerForm());
		}

		private void RainmakerForm_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			switch (e.KeyCode)
			{
				case Keys.F2:
					buttonSave_Click(sender, e);
					break;
				case Keys.F3:
					buttonLoad_Click(sender, e);
					break;
				case Keys.F5:
					numericUpDown_ValueChanged(sender, e);
					break;
				default:
					return;
			}
			e.Handled = true;
		}

		private void FormCascademaker_Paint(object sender, PaintEventArgs e)
		{
			if (images == null)
				CreateImages();

			Graphics g = e.Graphics;
			g.Clear(Color.Black);
			try
			{
				int x = (panelSettings.Left - images[frame].Width) / 2;
				for (int y = 0; y < ClientSize.Height; y += images[frame].Height)
				{
					g.DrawImageUnscaled(images[frame], x, y);
				}
			}
			catch (IndexOutOfRangeException ex) { }
			frame = (frame + 1) % frames;
		}

		private void timerPaint_Tick(object sender, EventArgs e)
		{
			Invalidate();
		}

		private void numericUpDown_ValueChanged(object sender, EventArgs e)
		{
			images = null;
		}

		private void buttonLoad_Click(object sender, System.EventArgs e)
		{
			if (openFileDialog.ShowDialog() != DialogResult.OK)
				return;

			if (!LoadSettings(openFileDialog.FileName))
			{
				MessageBox.Show("Not a valid settings file.",
					"Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			numericUpDown_ValueChanged(sender, e);
			saveFileDialog.FileName = openFileDialog.FileName;
		}

		private void buttonSave_Click(object sender, EventArgs e)
		{
			// Datenendung verwerfen, damit man problemlos das Dateiformat wechseln kann.
			saveFileDialog.FileName = new Regex(@"\.[^.]*$",
				RegexOptions.IgnoreCase).Replace(saveFileDialog.FileName, "");
			if (saveFileDialog.ShowDialog() != DialogResult.OK)
				return;

			// Die eingegebene Dateiendung wird praktisch ignoriert, relevant ist das im
			// Filter ausgewhlte Dateiformat.
			string[] filter = saveFileDialog.Filter.Split("|".ToCharArray());
			int index = saveFileDialog.FilterIndex * 2 - 1;
			if (index >= filter.Length)
			{
				MessageBox.Show("Invalid file format.", "Error", MessageBoxButtons.OK,
					MessageBoxIcon.Error);
				return;
			}

			switch (filter[index].Substring(2, 3).ToLower())
			{
				case "png":
					if (!saveFileDialog.FileName.ToLower().EndsWith(".png"))
						saveFileDialog.FileName += ".png";
					statusBar.Text = "Saving image sequence, please wait...";
					for (int i = 0; i < frames; i++)
					{
						string filename = new Regex(@"(?:_\d{3})?(?=\.[^.]*$)").Replace(
							saveFileDialog.FileName, String.Format("_{0:D3}", 1 + i));
						images[i].Save(filename, System.Drawing.Imaging.ImageFormat.Png);
					}
					break;
				default:
					if (!saveFileDialog.FileName.ToLower().EndsWith(".xml"))
						saveFileDialog.FileName += ".xml";
					SaveSettings(saveFileDialog.FileName);
					openFileDialog.FileName = saveFileDialog.FileName;
					break;
			}
		}

		private bool LoadSettings(string filename)
		{
			XmlDocument doc = new XmlDocument();
			try
			{
				doc.Load(filename);

				XmlNodeList window = doc.GetElementsByTagName("Window");
				if (window.Count > 0)
				{
					Width  = Convert.ToInt32(window[0].Attributes["width"].Value);
					Height = Convert.ToInt32(window[0].Attributes["height"].Value);
				}

				XmlNode node;
				foreach (Control control in panelSettings.Controls)
				{
					node = doc.SelectSingleNode("//Setting[@name='" + control.Name + "']/@value");
					if (node == null || node.NodeType != XmlNodeType.Attribute)
						continue;
					if (control is NumericUpDown)
						(control as NumericUpDown).Value = Convert.ToDecimal(node.Value, format);
					else if (control is ComboBox)
						(control as ComboBox).SelectedIndex = Convert.ToInt32(node.Value, format);
				}
			}
			catch
			{
				return false;
			}
			return true;
		}

		private void SaveSettings(string filename)
		{
			XmlDocument doc        = new XmlDocument();
			XmlNode root           = doc.CreateElement("SwarmmakerSettings");

			XmlNode node           = doc.CreateElement("Window");
			XmlAttribute attribute = doc.CreateAttribute("width");
			attribute.Value        = Width.ToString(format);
			node.Attributes.Append(attribute);
			attribute              = doc.CreateAttribute("height");
			attribute.Value        = Height.ToString(format);
			node.Attributes.Append(attribute);
			root.AppendChild(node);

			foreach (Control control in panelSettings.Controls)
			{
				string value;
				if (control is ComboBox)
					value = (control as ComboBox).SelectedIndex.ToString(format);
				else if (control is NumericUpDown)
					value = (control as NumericUpDown).Value.ToString(format);
				else
					continue;
				node            = doc.CreateElement("Setting");
				attribute       = doc.CreateAttribute("name");
				attribute.Value = control.Name;
				node.Attributes.Append(attribute);
				attribute       = doc.CreateAttribute("value");
				attribute.Value = value;
				node.Attributes.Append(attribute);
				root.AppendChild(node);
			}
			doc.AppendChild(root);
			doc.Save(filename);
		}

		private void CreateImages()
		{
			Random rand = new Random();
			frames = (int)numericUpDownFrames.Value;
			int width = (int)numericUpDownWidth.Value;
			int height = (int)numericUpDownHeight.Value;
			int count = (int)numericUpDownCount.Value;
			float speedMin = (float)numericUpDownMin.Value;
			float gravity = (float)numericUpDownGravity.Value;
			float size = (float)numericUpDownSize.Value;
			float trail = (float)numericUpDownTrail.Value;
			float fadeIn = (float)numericUpDownIn.Value;
			int alphaStart = (int)numericUpDownAlpha.Value;
			int fadeOut = (int)numericUpDownOut.Value;
			float slope = (float)numericUpDownSlope.Value;
			int slopeMax = width / 8;

			images = new Image[frames];
			graphics = new Graphics[frames];
			for (int f = 0; f < frames; f++)
			{
				images[f] = new Bitmap(width, height);
				graphics[f] = Graphics.FromImage(images[f]);
				graphics[f].SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias;
			}

			float x, y, y1;
			PointF[] points = new PointF[count];
			float[] speeds = new float[count];
			int[] startAtFrame = new int[count];
			int[] alpha = new int[count];
			for (int i = 0; i < count; i++)
			{
				float m = Math.Min(slope * i, slopeMax);
				x = m + (float)rand.Next() / (float)int.MaxValue * ((float)width - 2.0f * m);
				points[i] = new PointF(x,
					(float)rand.Next() / (float)int.MaxValue * (float)height);
				speeds[i] = speedMin;
				startAtFrame[i] = (int)Math.Round((double)i / (double)count * (double)frames) % frames;
				alpha[i] = alphaStart;
			}

			for (int f = 0; f < 8 * frames; f++)
			{
				statusBar.Text = "Rendering iteration " + (1 + f / frames) +
					", frame " + (1 + (f % frames)) + ", please wait...";

				Graphics g = graphics[f % frames];
				bool stop  = f >= frames;

				for (int p = 0; p < count; p++)
				{
					if (startAtFrame[p] > f || alpha[p] <= 0)
						continue;
					stop = false;

					float fading = Math.Min(1.0f, (speeds[p] - speedMin) * fadeIn);
					float radius = size * fading;
					Pen pen = new Pen(Color.FromArgb(Math.Min(255, Math.Min(Math.Abs(alpha[p]),
						(int)Math.Round(255.0 * Math.Abs(fading)))), Color.White));
					Brush brush = new SolidBrush(pen.Color);
					for (int q = (slope == 0 ? -1 : 0); q <= (slope == 0 ? 1 : 0); q++)
					{
						x = points[p].X + q * width;
						if (x < -radius || x > width + radius)
							continue;
						for (int r = -1; r <= 2; r++)
						{
							y = points[p].Y + r * height;
							if (y < -radius)
								continue;
							y1 = y - trail * speeds[p];
							if (y1 >= height + radius)
								continue;
							g.DrawLine(pen, x, y, x, y1);
							g.DrawLine(pen, x, y, x, y - trail * speeds[p] * 0.3f);
							g.FillEllipse(brush, x - radius * 0.5f, y - radius * 0.5f, radius, radius);
						}
					}

					points[p].Y += speeds[p];
					if (points[p].Y > height)
						points[p].Y -= height;
					speeds[p] += gravity;
					alpha[p] -= fadeOut;
				}
				if (stop)
					break;
				if (f % frames == 0) Refresh();
			}
		}
	}
}